package net.jumperz.app.MBangzone;

import java.io.*;
import java.util.*;

public class MConfig
{
private static MConfig instance = new MConfig();

private File configFile;
private Properties prop;
private int threadCount;
private String logFileName;
private boolean useProxy;
private String proxyHost;
private int proxyPort;

//-----------------------------------------------------------------------------------
private MConfig()
{
}
//-----------------------------------------------------------------------------------
public static MConfig getInstance()
{
return instance;
}
//-----------------------------------------------------------------------------------
public void load( String configFileName )
throws Exception
{
configFile = new File( configFileName );

prop = new Properties();
prop.load( new FileInputStream( configFile ) );

threadCount			= Integer.parseInt( prop.getProperty( "threadCount" ) );
logFileName			= prop.getProperty( "logFileName" );

if( prop.containsKey( "useProxy" ) )
	{
	useProxy = Boolean.valueOf( prop.getProperty( "useProxy" ) ).booleanValue();
	if( useProxy == true )
		{
		proxyHost = prop.getProperty( "proxyHost" );
		proxyPort = Integer.parseInt( prop.getProperty( "proxyPort" ) );
		}
	}
}
//-----------------------------------------------------------------------------------
public String getLogFileName()
{
return logFileName;
}
//-----------------------------------------------------------------------------------
public int getThreadCount()
{
return threadCount;
}
//-----------------------------------------------------------------------------------
public boolean getUseProxy()
{
return useProxy;
}
//-----------------------------------------------------------------------------------
public String getProxyHost()
{
return proxyHost;
}
//-----------------------------------------------------------------------------------
public int getProxyPort()
{
return proxyPort;
}
//-----------------------------------------------------------------------------------

}