package net.jumperz.app.MBitDog;

import java.io.*;
import java.util.*;
import net.jumperz.util.*;
import java.text.*;

public class MBitDog
{
private List loggerList;
//--------------------------------------------------------------------------------
public static void main( String[] args )
throws Exception
{
if( args.length != 1 )
	{
	System.out.println( "Usage: java net.jumperz.app.MBitDog.MBitDog CONFIGURE_FILENAME" );
	return;
	}
else
	{
	MBitDog instance = new MBitDog();
	instance.start( args[ 0 ] );
	}
}
//--------------------------------------------------------------------------------
private void start( String configFileName )
throws Exception
{
	// load loggers
loggerList = MLoggerFactory.load( configFileName );

	// get standard input
BufferedReader reader = new BufferedReader( new InputStreamReader( System.in, MCharset.CS_ISO_8859_1 ) );

	// read, read, read
String line;
while( true )
	{
	line = reader.readLine();
	if( line == null )
		{
		break;
		}
	Iterator p = loggerList.iterator();
	while( p.hasNext() )
		{
		MAbstractLogger logger = ( MAbstractLogger )p.next();
		if( logger.match( line ) )
			{
			logger.log( line );
			if( logger.isEater() )
				{
				break;
				}
			}
		}
	}

	// cleanup streams
Iterator p = loggerList.iterator();
while( p.hasNext() )
	{
	MAbstractLogger logger = ( MAbstractLogger )p.next();
	logger.cleanUp();
	}
}
//--------------------------------------------------------------------------------
}