package net.jumperz.app.MDoorman;

import net.jumperz.net.*;
import net.jumperz.util.*;
import java.net.*;
import java.io.*;

import javax.sound.midi.Receiver;

public class MAcceptorObserver
implements MObserver1
{
private MMultiAcceptor multiAcceptor;
private MThreadPool threadPool;
// --------------------------------------------------------------------------------
public MAcceptorObserver( MMultiAcceptor multiAcceptor, MThreadPool threadPool )
{
this.multiAcceptor = multiAcceptor;
this.threadPool = threadPool;
}
// --------------------------------------------------------------------------------
public void update()
{
int state = multiAcceptor.getState();
if( state == MMultiAcceptor.ACCEPTED )
	{
	Socket socket = multiAcceptor.getSocket();
	try
		{
		BufferedInputStream cIn = new BufferedInputStream( socket.getInputStream() );
		
		MRequestReceiver receiver = new MRequestReceiver( cIn );
		MRequestReceiverObserver1 observer = new MRequestReceiverObserver1( receiver, socket );
		receiver.register1( observer );
		threadPool.addCommand( receiver );
		}
	catch( IOException e )
		{	
		}
	}
else if( state == MMultiAcceptor.ERROR )
	{
	Exception e = multiAcceptor.getException();
	if( e instanceof BindException )
		{
		MDoorman.getInstance().notifyException( e );
		}
	MEngine.getInstance().stop();
	MDoorman.getInstance().updateGui();
	}
}
// --------------------------------------------------------------------------------
}