package net.jumperz.app.MDoorman;

import java.io.*;
import java.net.*;
import net.jumperz.util.*;
import net.jumperz.net.*;

public final class MRequestReceiverObserver1
implements MObserver1
{
private MRequestReceiver receiver;
private Socket socket;
// --------------------------------------------------------------------------------
public MRequestReceiverObserver1( MRequestReceiver receiver, Socket socket )
{
this.receiver = receiver;
this.socket = socket;
}
// --------------------------------------------------------------------------------
public void update()
{
int state = receiver.getState();
if( state == MRequestReceiver.SUCCESS )
	{
	MHttpRequest request = receiver.getRequest();
	if( request.getMethodType() == MHttpRequest.CONNECT )
		{
			//SSL
		MSslInitializer initializer = new MSslInitializer( request, receiver.getInputStream(), socket );
		initializer.execute();
		}
	else
		{
		try
			{		
			MSession session = new MSession( receiver.getInputStream(), socket.getOutputStream(), socket );
			session.onRequestReceived( request );
			}
		catch( IOException e )
			{
			MSystemUtil.closeSocket( socket );
			}
		}
	}
else if( state == MRequestReceiver.ERROR )
	{
	MSystemUtil.closeSocket( socket );
	}
}
// --------------------------------------------------------------------------------
}