package net.jumperz.app.MDoorman.windows;

import org.eclipse.swt.graphics.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.*;

import java.io.*;
import java.util.*;

import net.jumperz.app.MDoorman.*;
import net.jumperz.util.*;
import net.jumperz.gui.*;

public class MMainWindow
extends MWindow
{
private Menu bar, runDropMenu, windowDropMenu;
private MEngine engine;
private MenuItem runCascadeItem, windowCascadeMenu, startItem, stopItem, sessionWindowItem, requestWindowItem, responseWindowItem, optionWindowItem, lineItem1, getQueryWindowItem, postQueryWindowItem;
// --------------------------------------------------------------------------------
public MMainWindow()
{
super( MDoorman.APPLICATION_NAME, MDoorman.getInstance().mainShell );
}
// --------------------------------------------------------------------------------
protected void init2()
{
permanent = false;

shell.addListener( SWT.Activate, this );
engine = MEngine.getInstance();

bar = new Menu( shell, SWT.BAR );
shell.setMenuBar( bar );

runCascadeItem = new MenuItem( bar, SWT.CASCADE );
runCascadeItem.setText( "&Run" );

runDropMenu = new Menu( shell, SWT.DROP_DOWN );
runCascadeItem.setMenu( runDropMenu );

startItem = new MenuItem( runDropMenu, SWT.PUSH );
startItem.setText( "&Start Proxy" );

stopItem = new MenuItem( runDropMenu, SWT.PUSH );
stopItem.setText( "Sto&p Proxy" );

windowCascadeMenu = new MenuItem( bar, SWT.CASCADE, 1 );
windowCascadeMenu.setText( "&Window" );

windowDropMenu = new Menu( shell, SWT.DROP_DOWN );
windowCascadeMenu.setMenu( windowDropMenu );

optionWindowItem = new MenuItem( windowDropMenu, SWT.PUSH );
optionWindowItem.setText( "&Options" );
optionWindowItem.setAccelerator( SWT.F10 );

lineItem1 = new MenuItem( windowDropMenu, SWT.SEPARATOR );

sessionWindowItem = new MenuItem( windowDropMenu, SWT.PUSH );
sessionWindowItem.setText( "&Session" );

requestWindowItem = new MenuItem( windowDropMenu, SWT.PUSH );
requestWindowItem.setText( "&Request" );

responseWindowItem = new MenuItem( windowDropMenu, SWT.PUSH );
responseWindowItem.setText( "R&esponse" );

new MenuItem( windowDropMenu, SWT.SEPARATOR );

getQueryWindowItem = new MenuItem( windowDropMenu, SWT.PUSH );
getQueryWindowItem.setText( "&GET Query" );

postQueryWindowItem = new MenuItem( windowDropMenu, SWT.PUSH );
postQueryWindowItem.setText( "&POST Query" );

MSwtUtil.addListenerToMenuItems( windowDropMenu, this );
MSwtUtil.addListenerToMenuItems( runDropMenu, this );
}
// --------------------------------------------------------------------------------
protected void handleEvent2( Event event )
{
if( event.widget == shell )
	{
	switch( event.type )
		{
		case SWT.Activate:
			onActivate();
			break;
		}
	}
if( event.type == SWT.Selection )
	{
	if( event.widget == sessionWindowItem )
		{
		doorman.sessionWindow.open();
		}
	else if( event.widget == requestWindowItem )
		{
		doorman.requestWindow.open();
		}
	else if( event.widget == responseWindowItem )
		{
		doorman.responseWindow.open();
		}
	else if( event.widget == optionWindowItem )
		{
		doorman.optionWindow.getOptions();
		doorman.optionWindow.updateGui();
		doorman.optionWindow.open();
		}
	else if( event.widget == getQueryWindowItem )
		{
		doorman.getQueryWindow.open();
		}
	else if( event.widget == postQueryWindowItem )
		{
		doorman.postQueryWindow.open();
		}
	else if( event.widget == startItem )
		{
		onStartItemClick();
		}
	else if( event.widget == stopItem )
		{
		onStopItemClick();
		}
	}
updateGui();
}
// --------------------------------------------------------------------------------
protected void onShellResize()
{
saveWindowBounds();

Rectangle a = shell.getBounds();
a.height = 48;
shell.setBounds( a );
}
// --------------------------------------------------------------------------------
private void onStopItemClick()
{
engine.stop();
}
// --------------------------------------------------------------------------------
private void onStartItemClick()
{
doorman.peerWindow = new MPeerWindow();
doorman.peerWindow.open();
}
// --------------------------------------------------------------------------------
public void onActivate()
{
}
// --------------------------------------------------------------------------------
public void updateGui()
{
boolean isRun = engine.isRun();
startItem.setEnabled( !isRun );
stopItem.setEnabled( isRun );
}
// --------------------------------------------------------------------------------
protected void onClose2()
{
doorman.shutdown();
}
// --------------------------------------------------------------------------------
}