package net.jumperz.app.MDoorman.windows;

import org.eclipse.swt.graphics.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.*;

import java.io.*;
import java.util.*;

import net.jumperz.app.MDoorman.*;
import net.jumperz.util.*;

public class MPeerWindow
extends MWindow
{
private static final String WINDOW_NAME = "Proxy Configuration";
public static final int WINDOW_STYLE = SWT.CLOSE | SWT.APPLICATION_MODAL;

private Label peerLabel1;
private Text addressText;
private Label peerLabel2;
private Text portText;
private Button runButton;
private Button cancelButton;
// --------------------------------------------------------------------------------
public MPeerWindow()
{
super( WINDOW_NAME, new Shell( MDoorman.getInstance().mainShell, WINDOW_STYLE ) );
}
// --------------------------------------------------------------------------------
protected void handleEvent2( Event event )
{
if( event.widget == cancelButton )
	{
	switch( event.type )
		{
		case SWT.Selection:
			onCancelButtonClick();
			break;
		}
	}
else if( event.widget == addressText
	|| event.widget == portText
	)
	{
	switch( event.type )
		{
		case SWT.Modify:
			updateGui();
			break;
		}	
	}
else
	{
	switch( event.type )
		{
		case SWT.Selection:
			onRunButtonClick();
			break;
		}	
	}
}
// --------------------------------------------------------------------------------
private void updateGui()
{
boolean isOk = false;
String host = addressText.getText();
String portStr = portText.getText();
int port;

if( host.length() > 0 && portStr.length() > 0 )
	{
	try
		{
		port = Integer.parseInt( portStr );
		isOk = true;
		}
	catch( NumberFormatException e )
		{
		}	
	}

runButton.setEnabled( isOk );
}
// --------------------------------------------------------------------------------
private void onRunButtonClick()
{
String host = addressText.getText();
String portStr = portText.getText();
prop.setProperty( WINDOW_NAME + ".addressText", host );
prop.setProperty( WINDOW_NAME + ".portText", portStr );

int port = Integer.parseInt( portStr );
MEngine.getInstance().start( host, port );

close();
}
// --------------------------------------------------------------------------------
private void onCancelButtonClick()
{
close();
}
// --------------------------------------------------------------------------------
protected void init2()
{
windowValue = new int[]{ 150, 280, 100, 400 };
permanent = false;
shell.setLayout( null );

peerLabel1 = new Label(shell, SWT.NONE);
peerLabel1.setText("IP Address :");
peerLabel1.setSize(new Point(60,26));
peerLabel1.setLocation(new Point( LABEL1_LEFT, LABEL1_TOP ));
peerLabel1.pack();

addressText = new Text(shell, SWT.BORDER);
addressText.setText( prop.getProperty( WINDOW_NAME + ".addressText", _127_0_0_1 ) );
addressText.setLocation(new Point(95,20));
addressText.setSize(new Point(135,20));
addressText.addListener( SWT.Modify, this );

peerLabel2 = new Label(shell, SWT.NONE);
peerLabel2.setSize(new Point(60,26));
peerLabel2.setLocation(new Point(LABEL2_LEFT, LABEL2_TOP));
peerLabel2.setText("Port :");
peerLabel2.pack();

portText = new Text(shell, SWT.BORDER);
portText.setText( prop.getProperty( WINDOW_NAME + ".portText", _8080 ) );
portText.setLocation(new Point(95,50));
portText.setSize(new Point(135,20));
portText.addListener( SWT.Modify, this );

runButton = new Button( shell, SWT.NONE );
runButton.setText( "&Run" );
runButton.setLocation(new Point(120,85));
runButton.setSize(new Point( BUTTON_WIDTH, BUTTON_HEIGHT ) );
runButton.addListener( SWT.Selection, this);

cancelButton = new Button( shell, SWT.NONE );
cancelButton.setText( "&Cancel" );
cancelButton.setLocation(new Point(190,85));
cancelButton.setSize( new Point( BUTTON_WIDTH, BUTTON_HEIGHT ) );
cancelButton.addListener( SWT.Selection, this);

shell.setDefaultButton(runButton);
}
// --------------------------------------------------------------------------------
}