package net.jumperz.app.MGuardian.plugin;

import java.io.*;
import java.util.*;

public class MPluginManager
{
private static MPluginManager instance = new MPluginManager();

private Map pluginMap = new HashMap();
//--------------------------------------------------------------------------------
public static MPluginManager getInstance()
{
return instance;
}
//--------------------------------------------------------------------------------
public MGuardianPlugin getPlugin( String pluginName )
throws Exception
{
MGuardianPlugin plugin;
if( pluginMap.containsKey( pluginName ) )
	{
	plugin = ( MGuardianPlugin )pluginMap.get( pluginName );
	}
else
	{
	Class pluginClass = Class.forName( pluginName );
	plugin = ( MGuardianPlugin )pluginClass.newInstance();
	pluginMap.put( pluginName, plugin );
	}
return plugin;
}
//--------------------------------------------------------------------------------
public void startup()
throws IOException
{
Iterator p = pluginMap.values().iterator();
while( p.hasNext() )
	{
	MGuardianPlugin plugin = ( MGuardianPlugin )p.next();
	plugin.startup();
	}
}
//--------------------------------------------------------------------------------
public void shutdown()
{
Iterator p = pluginMap.values().iterator();
while( p.hasNext() )
	{
	MGuardianPlugin plugin = ( MGuardianPlugin )p.next();
	plugin.shutdown();
	}
}
//--------------------------------------------------------------------------------
public void clearPlugins()
{
pluginMap.clear();
}
//--------------------------------------------------------------------------------
}