package net.jumperz.app.MGuardian.rule;

import java.util.*;
import net.jumperz.net.MHttpResponse;

public final class MRuleGroup
extends MAbstractResponseRule
{
private ArrayList ruleList;
//-----------------------------------------------------------------------------------------
public MRuleGroup( ArrayList in_ruleList )
{
ruleList = in_ruleList;
}
//-----------------------------------------------------------------------------------------
public boolean matchesResponse( MHttpResponse response, MResultCache resultCache )
{
boolean match = true;
int ruleCount = ruleList.size();
for( int i = 0; i < ruleCount; ++i )
	{
	MAbstractRule rule = ( MAbstractRule )ruleList.get( i );
	
	if( !resultCache.containsResult( rule ) )
		{
		int ruleType = rule.getRuleType();
		if( ruleType == MAbstractRule.RESPONSE )
			{
			MAbstractResponseRule delayedRule = ( MAbstractResponseRule )rule;
			delayedRule.matches( response, resultCache );
			}
		else
			{
			Exception e = new Exception( "Exception. should not happen." );
			e.printStackTrace();
			return false;
			}
		}

	boolean ruleMatches = resultCache.getResult( rule );
	if( ruleMatches == false )
		{
		match = false;
		break;
		}
	}
match = ( match != negationFlag );
resultCache.cacheResult( this, match );
return match;
}
//-----------------------------------------------------------------------------------------
}