package net.jumperz.app.MTCPC_cui;

import java.net.*;
import java.io.*;
import net.jumperz.net.*;
import net.jumperz.util.*;

public class MTCPC_cui
{
private String Host;
private int port;
private MThreadPool ThreadPool;
private final int thread_count = 4;
private InputStream netInputStream;
private OutputStream netOutputStream;
//-----------------------------------------------------------
public static void main( String[] args )
{
if( args.length != 2 )
	{
	System.out.println( "usage: MTCPC_cui host port" );
	return;
	}
MTCPC_cui TCPC_cui = new MTCPC_cui( args[ 0 ], Integer.parseInt( args[ 1 ] ) );
TCPC_cui.connect();
}
//-----------------------------------------------------------
public MTCPC_cui( String IN_Host, int IN_port )
{
Host = IN_Host;
port = IN_port;
ThreadPool = new MThreadPool( thread_count );
}
//-----------------------------------------------------------
public void connect()
{
MConnector Connector = new MConnector( Host, port );
MConnectorObserver Observer = new MConnectorObserver( Connector, this );
Connector.register1( Observer );
ThreadPool.addCommand( Connector );
}
//-----------------------------------------------------------
public void startSession( Socket IN_socket )
{
try
	{
	netInputStream  = IN_socket.getInputStream();
	netOutputStream = IN_socket.getOutputStream();

	MStringReceiver NetReceiver = new MStringReceiver( netInputStream );
	MNetReceiverObserver NetObserver = new MNetReceiverObserver( NetReceiver, this );
	NetReceiver.register1( NetObserver );
	ThreadPool.addCommand( NetReceiver );

	MStringReceiver ConsoleReceiver = new MStringReceiver( System.in );
	MConsoleReceiverObserver ConsoleObserver = new MConsoleReceiverObserver( ConsoleReceiver, this );
	ConsoleReceiver.register1( ConsoleObserver );
	ThreadPool.addCommand( ConsoleReceiver );
	}
catch( IOException e )
	{
	e.printStackTrace();
	}
}
//-----------------------------------------------------------
public void send( String str )
{
byte[] buffer = str.getBytes();
MSender Sender = new MSender( netOutputStream, buffer );
ThreadPool.addCommand( Sender );
}
//-----------------------------------------------------------
public void exit()
{
System.exit( 0 );
}
//-----------------------------------------------------------
}
