package net.jumperz.app.MTCPS_cui;

import net.jumperz.util.*;
import net.jumperz.net.*;
import java.net.*;
import java.io.*;

public class MTCPS_cui
{
	//萔
private final int thread_count = 5;

private int port;
private MThreadPool ThreadPool;
private InputStream netInputStream;
private OutputStream netOutputStream;
//---------------------------------------------------------------------------------
public static void main( String args[] )
{
if( args.length != 1 )
	{
	System.out.println( "Usage: MTCPS_cui port" );
	return;
	}
MTCPS_cui TCPS_cui = new MTCPS_cui( Integer.parseInt( args[ 0 ] ) );
TCPS_cui.start();
}
//---------------------------------------------------------------------------------
public MTCPS_cui( int IN_port )
{
port = IN_port;
ThreadPool = new MThreadPool( thread_count );
}
//---------------------------------------------------------------------------------
public void start()
{
MSingleAcceptor acceptor = new MSingleAcceptor( port );
MAcceptorObserver observer = new MAcceptorObserver( acceptor, this );
acceptor.register1( observer );
ThreadPool.addCommand( acceptor );
}
//---------------------------------------------------------------------------------
public void startSession( Socket IN_socket )
{
try
	{
	netInputStream = IN_socket.getInputStream();
	netOutputStream = IN_socket.getOutputStream();

	MStringReceiver netReceiver = new MStringReceiver( netInputStream );
	MNetReceiverObserver netObserver = new MNetReceiverObserver( netReceiver, this );
	netReceiver.register1( netObserver );
	ThreadPool.addCommand( netReceiver );

	MStringReceiver consoleReceiver = new MStringReceiver( System.in );
	MConsoleReceiverObserver consoleObserver = new MConsoleReceiverObserver( consoleReceiver, this );
	consoleReceiver.register1( consoleObserver );
	ThreadPool.addCommand( consoleReceiver );
	}
catch( IOException e )
	{
	e.printStackTrace();
	}
}
//---------------------------------------------------------------------------------
public void send( String str )
{
byte[] buffer = str.getBytes();
MSender sender = new MSender( netOutputStream, buffer );
ThreadPool.addCommand( sender );
}
//---------------------------------------------------------------------------------
public void exit()
{
System.exit( 0 );
}
//---------------------------------------------------------------------------------
}
