package net.jumperz.app.httptunnel;

import java.util.*;

public final class MSessionManager
{
private HashMap sessionMap;

private static MSessionManager instance;
//----------------------------------------------------------------------------------
public final static synchronized MSessionManager getInstance()
{
if( MSessionManager.instance == null )
	{
	instance = new MSessionManager();
	}
return instance;
}
//----------------------------------------------------------------------------------
private MSessionManager()
{
instance = this;
sessionMap = new HashMap();
}
//----------------------------------------------------------------------------------
public final synchronized void putSession( MSession session )
{
sessionMap.put( session.getSessionName(), session );
}
//----------------------------------------------------------------------------------
public final synchronized MSession getSession( String sessionName )
{
return ( MSession )sessionMap.get( sessionName );
}
//----------------------------------------------------------------------------------
public final synchronized void removeSession( MSession session )
{
String sessionName = session.getSessionName();
sessionMap.remove( sessionName );
}
//----------------------------------------------------------------------------------
public final synchronized int getSessionCount()
{
return sessionMap.size();
}
//----------------------------------------------------------------------------------
public final synchronized MSession[] getSessionList()
{
return ( MSession[] )sessionMap.values().toArray();
}
//----------------------------------------------------------------------------------
public final synchronized boolean sessionExists( MSession session )
{
return sessionMap.containsValue( session );
}
//----------------------------------------------------------------------------------
public final synchronized boolean sessionExists( String sessionName )
{
return sessionMap.containsKey( sessionName );
}
//----------------------------------------------------------------------------------
}
