package net.jumperz.util;

import net.jumperz.ext.org.jrobin.core.*;
import net.jumperz.ext.org.jrobin.graph.*;
import java.io.*;

public class MRrdUtil
{
//--------------------------------------------------------------------------------
public static RrdDb createStandardRrdFile( String rrdFileName, String dataSourceName )
throws IOException
{
try
	{
	RrdDef rrdDef = new RrdDef( rrdFileName );
	rrdDef.setStartTime( ( System.currentTimeMillis() ) / 1000  ); // now
	rrdDef.addDatasource( dataSourceName, "GAUGE", 600, 0, Double.NaN );
	rrdDef.addArchive( "AVERAGE", 0.5, 1, 600 );
	rrdDef.addArchive( "AVERAGE", 0.5, 6, 700 );
	rrdDef.addArchive( "AVERAGE", 0.5, 24, 775 );
	rrdDef.addArchive( "AVERAGE", 0.5, 288, 797 );
	rrdDef.addArchive( "MAX", 0.5, 1, 600 );
	rrdDef.addArchive( "MAX", 0.5, 6, 700 );
	rrdDef.addArchive( "MAX", 0.5, 24, 775 );
	rrdDef.addArchive( "MAX", 0.5, 288, 797 );
	RrdDb rrdDb = new RrdDb( rrdDef );
	return rrdDb;
	}
catch( RrdException e )
	{
	throw new IOException( e.getMessage() );
	}
}
//--------------------------------------------------------------------------------
}